; vector rotation (formula by lvd^mHm 2014, optimized by Alone Coder 2016)
;  ix

;        ( -sb                     )
;rot*V = ( -1/2[ s(a+b) + s(a-b) ] )
;        (  1/2[ c(a+b) + c(a-b) ] )

;         ( 1/2[ s(b-c) - s(b+c) ]                                                    )
;rot*S1 = ( 1/2[ c(a+c) + c(a-c) ] + 1/4[ s(a-b+c) - s(a-b-c) - s(a+b+c) + s(a+b-c) ] )
;         ( 1/2[ s(a+c) + s(a-c) ] - 1/4[ c(a+b-c) - c(a+b+c) - c(a-b-c) + c(a-b+c) ] )

;         ( 1/2[ c(b+c) + c(b-c) ]                                                    )
;rot*S2 = ( 1/2[ s(a+c) - s(a-c) ] - 1/4[ c(a-b+c) + c(a-b-c) - c(a+b+c) - c(a+b-c) ] )
;         ( 1/2[ c(a-c) - c(a+c) ] + 1/4[ s(a+b+c) + s(a+b-c) - s(a-b+c) - s(a-b-c) ] )

;V = (0,0,1)
;S1 = (0,1,0)
;S2 = (1,0,0)

;    :
;1. +  ( Z(=yscr) -  GAMMA)
;2.  () ( Y(=xscr) -  BETA)
;3.  ,   ( X(=zscr) -  ALPHA)

	;.ALIGN 256
	BEGIN256 768
CUTS
	ds 768
	END256

        MACRO   DIVA2
        RLCA 
        RRCA 
        JP      PO,$+4
        CCF 
       ;inc a ;- 
        RRA 
        ;ADC     A,0 ; (0>0, 1>1, 2>1, 3>2, 4>2, 5>3...) ?
        ENDM 

	MACRO SUM1
;sum = +c0-c1+c2-c3
;h,l,d,e
	xor a
	sub h ;c1
	ld c,a
	rla
	sbc a,a
	ld b,a
	ld a,l ;c0
	rla
	sbc a,a
	ld h,a
	add hl,bc
	xor a
	sub d ;c3
	ld c,a
	rla
	sbc a,a
	ld b,a
	add hl,bc
	ld a,e ;c2
	;ld c,a
	rla
	sbc a,a
	ld d,a;b,a
	add hl,de;bc
	sra h
	rr l
	inc hl ;    2    (0>0, 1>0, 2>1, 3>1, 4>1, 5>1, 6>2...)
	ENDM

	MACRO SUM2
;sum2= +c0-c1-c2+c3
;b,c,d,e (keep de)
	xor a
	sub b ;c1
	ld l,a
	rla
	sbc a,a
	ld h,a
	ld a,c ;c0
	;ld l,a
	rla
	sbc a,a
	ld b,a;h,a
	add hl,bc
	xor a
	sub e ;c2
	ld c,a
	rla
	sbc a,a
	ld b,a
	add hl,bc
	ld a,d ;c3
	ld c,a
	rla
	sbc a,a
	ld b,a
	add hl,bc
	sra h
	rr l
	inc hl ;    2    (0>0, 1>0, 2>1, 3>1, 4>1, 5>1, 6>2...)
	ENDM

MK_ROTS
;---
	ld bc,(beta) ;b=B,c=C
	ld l,b ;B
	ld h,TSIN/256
	xor a
	sub (hl)
	if MATRIXDIV2
	sra a
	endif
	ld (Vx),a ;-sin(B)

	ld a,(alpha)
	ld ly,a ;A
	sub l
	ld e,a ;A-B
	add a,l
	add a,l
	ld l,a ;A+B
	add a,#40 ;cos
	ld d,a
	xor a
	sub (hl) ;sin(A+B)
	ld l,e ;A-B
	sub (hl) ;sin(A-B)
       DIVA2
	if MATRIXDIV2
	sra a
	endif
	ld (Vy),a ;-1/2[sin(A+B)+sin(A-B)]
	ld a,l
	add a,#40 ;cos
	ld l,a
	ld a,(hl) ;cos(A-B)
	ld l,d
	add a,(hl) ;cos(A+B)
       DIVA2
	if MATRIXDIV2
	sra a
	endif
	ld (Vz),a ;1/2[cos(A+B)+cos(A-B)]

;---
	ld a,b ;B
	add a,c ;C
	ld e,a ;B+C
	sub c
	sub c
	ld l,a ;B-C
	add a,#40 ;cos
	ld d,a ;B-C+pi/2
	ld a,(hl) ;sin(B-C)
	ld l,e
	sub (hl) ;sin(B+C)
       DIVA2
	if MATRIXDIV2
	sra a
	endif
	ld (S1x),a ;1/2[sin(B-C)-sin(B+C)]
	ld a,l
	add a,#40 ;cos
	ld l,a
	ld a,(hl) ;cos(B+C)
	ld l,d
	add a,(hl) ;cos(B-C)
       DIVA2
	if MATRIXDIV2
	sra a
	endif
	ld (S2x),a ;1/2(cos(B+C)+cos(B-C)]

;--- prepare big formula
	ld a,ly;(alpha)
	sub c ;C
	ld l,a ;A-C
	;ld h,TSIN/256
	ld e,(hl) ;sin(A-C)
	ld a,l ;A-C
	add a,c
	add a,c
	ld l,a ;A+C
	ex af,af' ;A+C
	ld l,(hl) ;sin(A+C)
	ld a,l
	rla
	sbc a,a
	ld h,a ;sApC
	ld a,e
	rla
	sbc a,a
	ld d,a ;sAmC
	or a
	sbc hl,de
	;ld (sApC_m_sAmC),hl ;[sin(A+C)-sin(A-C)]
	push hl ;[sin(A+C)-sin(A-C)]
	add hl,de
	add hl,de
	ld (sApC_p_sAmC),hl ;[sin(A+C)+sin(A-C)]
	;push hl ;[sin(A+C)+sin(A-C)]

	ld h,TSIN/256
	ex af,af' ;A+C
	add a,#40
	ld l,a ;A+C+pi/2
	ld e,(hl) ;cos(A+C)
	sub c
	sub c
	ld l,a ;A-C+pi/2
	ld l,(hl) ;cos(A-C)
	ld a,l
	rla
	sbc a,a
	ld h,a ;cAmC
	ld a,e
	rla
	sbc a,a
	ld d,a ;cApC
	or a
	sbc hl,de
	ld (cAmC_m_cApC),hl ;[cos(A-C)-cos(A+C)]
	;push hl ;[cos(A-C)-cos(A+C)]
	add hl,de
	add hl,de
	ld (cAmC_p_cApC),hl ;[cos(A-C)+cos(A+C)]
	;push hl ;[cos(A-C)+cos(A+C)]

;--- do big formula
	ld a,ly;(alpha)
	add a,c ;A+C
	sla c ;2C
	; ld hx,c
	add a,b ;A+B+C
	sla b ;2B
	; ld lx,b
	push bc

	; ex af,af' ;A+B+C
	;sub #40 ;sin
	ld h,TSIN/256
	ld l,a
	sub b;e ;2B
	ld d,(hl) ;sin(A+B+C) ;c3
	ld l,a
	sub c;d ;2C
	ld e,(hl) ;sin(A-B+C) ;c2
	ld l,a
	add a,b;lx;b;e ;2B
	ld b,(hl) ;sin(A-B-C) ;c1
	ld l,a
	ld c,(hl) ;sin(A+B-C) ;c0
	ex af,af' ;A+B-C
	push bc ;c1,c0

	SUM2 ;+1/2 [ s(a+b+c) + s(a+b-c) - s(a-b+c) - s(a-b-c) ]
cAmC_m_cApC=$+1
	ld bc,#0101 ;[cos(A-C)-cos(A+C)]
	;pop bc ;[cos(A-C)-cos(A+C)]
	add hl,bc
	sra h
	ld a,l
	rra
	if MATRIXDIV2
	sra a
	endif
	ld (S2z),a ;1/2[ c(a-c) - c(a+c) ] + 1/4[ s(a+b+c) + s(a+b-c) - s(a-b+c) - s(a-b-c) ]

	pop hl ;c1,c0
	SUM1 ;+1/2 [ s(a-b+c) - s(a-b-c) - s(a+b+c) + s(a+b-c) ]
cAmC_p_cApC=$+1
	ld bc,#0101 ;[cos(A-C)+cos(A+C)]
	;pop bc ;[cos(A-C)+cos(A+C)]
	add hl,bc
	sra h
	ld a,l
	rra
	if MATRIXDIV2
	sra a
	endif
	ld (S1y),a ;1/2[ c(a+c) + c(a-c) ] + 1/4[ s(a-b+c) - s(a-b-c) - s(a+b+c) + s(a+b-c) ]

;---
	;ld de,(BETA) ;d=C,e=B
	;ld a,(ALPHA)
	;sub d
	;sla d ;d=2C
	; ld hx,d
	;add a,e ;A+B-C
	;sla e ;e=2B
	; ld lx,e

	pop bc
	
	 ex af,af' ;A+B-C
	add a,#40 ;cos
	ld h,TSIN/256
	ld l,a
	sub b;lx;e ;2B
	ld e,(hl) ;cos(A+B-C) ;c2
	ld l,a
	add a,c;hx;d ;2C
	ld d,(hl) ;cos(A-B-C) ;c3
	ld l,a
	add a,b;lx;e ;2B
	ld b,(hl) ;cos(A-B+C) ;c1
	ld l,a
	ld c,(hl) ;cos(A+B+C) ;c0
	;ex af,af' ;A+B+C
	push bc ;c1,c0

	SUM2 ;-1/2 [ c(a+b-c) - c(a+b+c) - c(a-b-c) + c(a-b+c) ]
sApC_p_sAmC=$+1
	ld bc,#0101 ;[sin(A+C)+sin(A-C)]
	;pop bc ;[sin(A+C)+sin(A-C)]
	add hl,bc
	sra h
	ld a,l
	rra
	if MATRIXDIV2
	sra a
	endif
	ld (S1z),a ;1/2[ s(a+c) + s(a-c) ] - 1/4[ c(a+b-c) - c(a+b+c) - c(a-b-c) + c(a-b+c) ]

	pop hl ;c1,c0
	SUM1 ;-1/2 [ c(a-b+c) + c(a-b-c) - c(a+b+c) - c(a+b-c) ]
;sApC_m_sAmC=$+1
	;ld bc,#0101 ;[sin(A+C)-sin(A-C)]
	pop bc ;[sin(A+C)-sin(A-C)]
	add hl,bc
	sra h
	ld a,l
	rra
	if MATRIXDIV2
	sra a
	endif
	ld (S2y),a ;1/2[ s(a+c) - s(a-c) ] - 1/4[ c(a-b+c) + c(a-b-c) - c(a+b+c) - c(a+b-c) ]

	;ds 1400
	if 1==1
; 
;  push hl,        
;9  (   OXx,OXy,OXz, OYx,OYy,OYz, OZx,OZy,OZz)
;:
;CUTS+#000...#01f = OXx ;CUTS+#000...#01f = OXy
;6156t  31  (63    ) -  10 
;3078t  15  (31    ) -  5 
	ld (mkcutssp),sp
	ld de,MATRIX
;_=0
;_sp=CUTS+#80 ;#00..#1f = stack for INT
	ld hl,CUTS+#80
	ld b,3
mkcuts0
	ld sp,hl;_sp
	dup 3
	ld a,(de);(MATRIX+_)
	inc e
	exx
	add a,a ;*2
	ld l,a
	sbc a,a
	ld h,a
	add hl,hl ;*4
	 add hl,hl ;*8
	ld d,h
	ld e,l ;de=m*8
	ld b,0
	dup 15
	ld c,h
	push bc
	add hl,de
	ld b,h
	add hl,de
	edup ;de*0..de*29
	ld c,h
	push bc ;de*30..de*31
	exx
;_=_+1
	edup
;_sp=_sp+#100
	inc h
	dec b
	jp nz,mkcuts0
mkcutssp=$+1
	ld sp,0
	endif

	ret


